/*
+--------------------------------------+
|  (C) Jaroslaw Arabas, luty 1999      |
+--------------------------------------+
*/

#include <stdlib.h>
#include <stdio.h>
#include <assert.h>
#include "pop.h"
#include "losowe.h"
#include "algorytm.h"
#include "raporty.h"
#include "genetyka.h"
#include "selekcja.h"
#include "stop.h"
#include "wewy.h"
#include "zadanie.h"

ALGORYTM Algorytm;

/* Funkcja tworzy populacje Ot z populacji Pt poprzez krzyzowanie (wraz z 
reprodukcja) oraz mutacje */
 
char genetyka (POP Pt, POP Ot)
{
   unsigned i,j;
   unsigned nSkopiowanych;
   unsigned Operator;
   unsigned OperatorM;
   unsigned *Rodzice;
   OSOBNIK *Dzieci;
   
   i=0;

   Rodzice=(unsigned*)calloc(Pt->nOsobnik, sizeof (unsigned));
   Dzieci=(OSOBNIK*)calloc(Ot->nOsobnik, sizeof (OSOBNIK));

   nSkopiowanych=0;
   while (nSkopiowanych < Ot->nOsobnik)
   {
      Operator = wyborOperatora (Operatory,0); 
      reprodukcja(Pt, Rodzice, Operatory->nRodzicow[Operator]);
      for(j=0; j<Operatory->nDzieci[Operator]; j++)
         Dzieci[j]=osNowy();
      operatorG(Operatory->tOperatoraC[Operator],Pt->Osobniki, Rodzice, 
                Operatory->nRodzicow[Operator],
                Operatory->nDzieci[Operator], Dzieci);
      
      for (i=0; i<Operatory->nDzieci[Operator] && nSkopiowanych < Ot->nOsobnik ; i++)
      {
         if (Operatory->NakladanieOp>0)
         {
            OperatorM = wyborOperatora (Operatory,1); 
       
            operatorG (Operatory->tOperatoraM[OperatorM],Dzieci, &i, 
                       1, 1, Dzieci+i);
         }
         Ot->Osobniki[nSkopiowanych++]=Dzieci[i];
      }
   }

   free(Rodzice);
   free(Dzieci);

   return 0;
}

/* Glowna petla algorytmu ewolucyjnego */
void petlaGlowna()
{
   POP Pt, Ot, Pnowa;
   unsigned t=0;

   Pt=popNowa(Algorytm->nPop);

   popOsobniki(Pt); /*proteza*/
   popInic(Pt); /*proteza*/

   popEwaluacja(Pt);
   popMonitor(Pt);
   zadMonitor(t,Pt);
   
   while (!krytStopu(Zadanie))
   {
      rapPop(Pt,NULL);
      rapZadanie(Zadanie,NULL);
      Ot=popNowa(Algorytm->nPop);
      genetyka(Pt, Ot);
      popEwaluacja(Ot);
      popMonitor(Ot);
      Pnowa=popNowa(Algorytm->nPop);
      sukcesja(Pnowa, Pt, Ot);
      popUsun(Pt);
      popUsun(Ot);
      t++;
      Pt=Pnowa;
      popMonitor(Pt);
      zadMonitor(t,Pt);
   }
   rapPop(Pt,NULL);
   rapZadanie(Zadanie,NULL);

}

#define ALG_PAR 2
void okreslAlgorytm (FILE *plikKonf, FILE* plikKontr)
{

   char Wczytanych;
   char *Nazwy[ALG_PAR];
   CZYTFUN czytFun[ALG_PAR];
   void *Adresy[ALG_PAR];
   unsigned *Liczba[ALG_PAR];

   Algorytm = (ALGORYTM) malloc(sizeof(ALGORYTMS));
   assert(Algorytm!=NULL);
   Algorytm->Samoadaptacja=0;

   Nazwy[0]="npop"; czytFun[0]=czytUnsigned; Adresy[0]=&(Algorytm->nPop); Liczba[0]=NULL;
   Nazwy[1]="samoadaptacja"; czytFun[1]=czytUnsigned; Adresy[1]=&(Algorytm->Samoadaptacja); Liczba[1]=NULL;

   Wczytanych = wczytajSymbole (plikKonf, plikKontr, Nazwy, czytFun, Adresy, Liczba, ALG_PAR);
   /*assert (Wczytanych==ALG_PAR);*/

}



