/*
+--------------------------------------+
|  (C) Jaroslaw Arabas, luty 1999      |
+--------------------------------------+
*/

#include <stdlib.h>
#include <math.h>
#include <assert.h>
#include "osobnik.h"
#include "losowe.h"
#include "zadanie.h"
#include "pop.h"
#include "genetyka.h"
#include "wewy.h"

OPERATORY Operatory;


char kopiowanie (const OSOBNIK *, const unsigned *, const unsigned , const unsigned , const OSOBNIK *);
char kRown (const OSOBNIK *, const unsigned *, const unsigned , const unsigned , const OSOBNIK *);
char k1p (const OSOBNIK *, const unsigned *, const unsigned , const unsigned , const OSOBNIK *);
char kKp (const OSOBNIK *, const unsigned *, const unsigned , const unsigned , const OSOBNIK *);
char kUsrStd (const OSOBNIK *, const unsigned *, const unsigned , const unsigned , const OSOBNIK *);
char kUsrMod (const OSOBNIK *, const unsigned *, const unsigned , const unsigned , const OSOBNIK *);
char kNRown (const OSOBNIK *, const unsigned *, const unsigned , const unsigned , const OSOBNIK *);
char kNUsrStd (const OSOBNIK *, const unsigned *, const unsigned , const unsigned , const OSOBNIK *);
char kNUsrMod (const OSOBNIK *, const unsigned *, const unsigned , const unsigned , const OSOBNIK *);
char mDysk (const OSOBNIK *, const unsigned *, const unsigned , const unsigned , const OSOBNIK *);
char mProst (const OSOBNIK *, const unsigned *, const unsigned , const unsigned , const OSOBNIK *);
char mNorm (const OSOBNIK *, const unsigned *, const unsigned , const unsigned , const OSOBNIK *);
char mCauchy (const OSOBNIK *, const unsigned *, const unsigned , const unsigned , const OSOBNIK *);


char operatorG (unsigned Nr, const OSOBNIK *Osobniki, const unsigned *Rodzice, 
               const unsigned nRodzicow, const unsigned nDzieci,
               const OSOBNIK *Dzieci)
{
   switch (Nr)
   {
   case 0: return kopiowanie (Osobniki, Rodzice, nRodzicow, nDzieci, Dzieci);
   case 1: return kRown (Osobniki, Rodzice, nRodzicow, nDzieci, Dzieci);
   case 2: return k1p (Osobniki, Rodzice, nRodzicow, nDzieci, Dzieci);
   case 3: return kKp (Osobniki, Rodzice, nRodzicow, nDzieci, Dzieci);
   case 4: return kUsrStd (Osobniki, Rodzice, nRodzicow, nDzieci, Dzieci);
   case 5: return kUsrMod (Osobniki, Rodzice, nRodzicow, nDzieci, Dzieci);
   case 6: return kNRown (Osobniki, Rodzice, nRodzicow, nDzieci, Dzieci);
   case 7: return kNUsrStd (Osobniki, Rodzice, nRodzicow, nDzieci, Dzieci);
   case 8: return kNUsrMod (Osobniki, Rodzice, nRodzicow, nDzieci, Dzieci);
   case 9: return mDysk (Osobniki, Rodzice, nRodzicow, nDzieci, Dzieci);
   case 10: return mProst (Osobniki, Rodzice, nRodzicow, nDzieci, Dzieci);
   case 11: return mNorm (Osobniki, Rodzice, nRodzicow, nDzieci, Dzieci);
   case 12: return mCauchy (Osobniki, Rodzice, nRodzicow, nDzieci, Dzieci);
   }
}

/* Funkcja zwraca numer operatora z tablicy wszystkich dostepnych */
unsigned wyborOperatora (const OPERATORY Operatory, unsigned ktore)
{
   if (ktore==0)
   return ruletka(Operatory->PstwoC, Operatory->nOperatorowC);
   if (ktore==1)
   return ruletka(Operatory->PstwoM, Operatory->nOperatorowM);
}


char kopiowanie (const OSOBNIK *Osobniki, const unsigned *Rodzice,
                 const unsigned nRodzicow, const unsigned nDzieci,
                 const OSOBNIK *Dzieci)
{

   unsigned i;
   unsigned Rodzic; 
   unsigned Dziecko; 

   assert(nRodzicow==nDzieci);
   for (Dziecko=0; Dziecko<nDzieci; Dziecko++)
   {
      Rodzic=Dziecko;
      for (i=0; i< Osobniki[Rodzice[Rodzic]]->nGenow ; i++)
         Dzieci[Dziecko]->Genotyp[i] = Osobniki[Rodzice[Rodzic]]->Genotyp[i];
      for (i=0; i< Osobniki[Rodzice[Rodzic]]->nPar; i++)
         Dzieci[Dziecko]->Parametry[i] = Osobniki[Rodzice[Rodzic]]->Parametry[i];
   }
   return 0;
}
/***************************************************************************/
/*               DWUOSOBNICZE KRZYZOWANIE 2->2                             */
/***************************************************************************/


/*----------------------------------------------------------------------------
Krzyzowanie rownomierne. 

G. Syswerda proponowal ustalic pstwo wymiary 0.5, tutaj natomiast jest ono
zmienna losowa o rozkladzie rownomiernym.

Uogolnione na przypadek samoczynnej adaptacji.
----------------------------------------------------------------------------*/
char kRown (const OSOBNIK *Osobniki, const unsigned *Rodzice,
            const unsigned nRodzicow, const unsigned nDzieci,
            const OSOBNIK *Dzieci)
{
   double PstwoZamiany;
   unsigned i;


   assert(nRodzicow==2);
   assert(nDzieci==2);

   PstwoZamiany = prostokatny(0,1);

   for (i=0; i< Osobniki[Rodzice[0]]->nGenow ; i++)
   {
      if (dwupunktowy(PstwoZamiany))
      {
         Dzieci[0]->Genotyp[i] = Osobniki[Rodzice[1]]->Genotyp[i];
         Dzieci[1]->Genotyp[i] = Osobniki[Rodzice[0]]->Genotyp[i];
         if (Osobniki[Rodzice[0]]->nPar==Osobniki[Rodzice[0]]->nGenow)
         {
            Dzieci[0]->Parametry[i] = Osobniki[Rodzice[1]]->Parametry[i];
            Dzieci[1]->Parametry[i] = Osobniki[Rodzice[0]]->Parametry[i];
         }

      }
      else
      {
         Dzieci[0]->Genotyp[i] = Osobniki[Rodzice[0]]->Genotyp[i];
         Dzieci[1]->Genotyp[i] = Osobniki[Rodzice[1]]->Genotyp[i];
         if (Osobniki[Rodzice[0]]->nPar==Osobniki[Rodzice[0]]->nGenow)
         {
            Dzieci[0]->Parametry[i] = Osobniki[Rodzice[0]]->Parametry[i];
            Dzieci[1]->Parametry[i] = Osobniki[Rodzice[1]]->Parametry[i];
         }
      }
   }

   return 0;
}

/*----------------------------------------------------------------------------
Krzyzowanie jednopunktowe. Uogolnione na przypadek samoczynnej adaptacji.
----------------------------------------------------------------------------*/

char k1p (const OSOBNIK *Osobniki, const unsigned *Rodzice,
            const unsigned nRodzicow, const unsigned nDzieci,
            const OSOBNIK *Dzieci)
{
   unsigned Punkt;
   unsigned i;

   assert(nRodzicow==2);
   assert(nDzieci==2);

   Punkt = rownomierny (Osobniki[Rodzice[0]]->nGenow -2)+1;

   for (i=0; i<Punkt; i++)
   {
      Dzieci[0]->Genotyp[i] = Osobniki[Rodzice[0]]->Genotyp[i];
      Dzieci[1]->Genotyp[i] = Osobniki[Rodzice[1]]->Genotyp[i];
   }
   if (Osobniki[Rodzice[0]]->nPar==Osobniki[Rodzice[0]]->nGenow)
      for (i=0; i<Punkt; i++)
      {
         Dzieci[0]->Parametry[i] = Osobniki[Rodzice[0]]->Parametry[i];
         Dzieci[1]->Parametry[i] = Osobniki[Rodzice[1]]->Parametry[i];
      }

   for ( i=Punkt; i< Osobniki[Rodzice[0]]->nGenow ; i++)
   {
      Dzieci[0]->Genotyp[i] = Osobniki[Rodzice[1]]->Genotyp[i];
      Dzieci[1]->Genotyp[i] = Osobniki[Rodzice[0]]->Genotyp[i];
   }
   if (Osobniki[Rodzice[0]]->nPar==Osobniki[Rodzice[0]]->nGenow)
      for ( i=Punkt; i< Osobniki[Rodzice[0]]->nGenow ; i++)
      {
         Dzieci[0]->Parametry[i] = Osobniki[Rodzice[1]]->Parametry[i];
         Dzieci[1]->Parametry[i] = Osobniki[Rodzice[0]]->Parametry[i];
      }

   return 0;
}
/*----------------------------------------------------------------------------
Krzyzowanie k-punktowe. Wybierane jest losowo k punktow w taki sposob, ze
punkty nie zachodza na siebie nawzajem, tzn. jedno miejse krzyzowania nie
moze byc wielokrotnie wybrane.
Uogolnione na przypadek samoczynnej adaptacji.
----------------------------------------------------------------------------*/

char kKp (const OSOBNIK *Osobniki, const unsigned *Rodzice,
            const unsigned nRodzicow, const unsigned nDzieci,
            const OSOBNIK *Dzieci)
{
   unsigned *Punkty;
   unsigned i, j;
   char Zamiana;

   assert(nRodzicow==2);
   assert(nDzieci==2);

/* przygotowanie tablicy na punkty krzyzowania    */
   Punkty = (unsigned*)calloc (Operatory->nPKrzyz, sizeof(unsigned));
   kombinacja (Punkty, Osobniki[Rodzice[0]]->nGenow, Operatory->nPKrzyz);

/* wlasciwe krzyzowanie       */
   Zamiana=0;
   j=0;
   for (i=0; i<Osobniki[Rodzice[0]]->nGenow; i++)
   {
      if (i==Punkty[j])
         {
         Zamiana = !Zamiana;
         j++;
         }

      if (Zamiana)
      {
         Dzieci[0]->Genotyp[i] = Osobniki[Rodzice[1]]->Genotyp[i];
         Dzieci[1]->Genotyp[i] = Osobniki[Rodzice[0]]->Genotyp[i];
         if (Osobniki[Rodzice[0]]->nPar==Osobniki[Rodzice[0]]->nGenow)
         {
            Dzieci[0]->Parametry[i] = Osobniki[Rodzice[1]]->Parametry[i];
            Dzieci[1]->Parametry[i] = Osobniki[Rodzice[0]]->Parametry[i];
         }
      }
      else
      {
         Dzieci[0]->Genotyp[i] = Osobniki[Rodzice[0]]->Genotyp[i];
         Dzieci[1]->Genotyp[i] = Osobniki[Rodzice[1]]->Genotyp[i];
         if (Osobniki[Rodzice[0]]->nPar==Osobniki[Rodzice[0]]->nGenow)
         {
            Dzieci[0]->Parametry[i] = Osobniki[Rodzice[0]]->Parametry[i];
            Dzieci[1]->Parametry[i] = Osobniki[Rodzice[1]]->Parametry[i];
         }
      }
   }

/* czynnosci porzadkowe */
   free (Punkty);

   return 0;
}

/*----------------------------------------------------------------------------
Krzyzowanie usredniajace --- standardowe (wzdluz odcinka).
Uogolnione na przypadk samoczynnej adaptacji - rownomierne tutaj.
----------------------------------------------------------------------------*/

char kUsrStd (const OSOBNIK *Osobniki, const unsigned *Rodzice,
            const unsigned nRodzicow, const unsigned nDzieci,
            const OSOBNIK *Dzieci)
{
   double a;
   unsigned i;


   assert(nRodzicow==2);
   assert(nDzieci==2);

   a = jednostajny();
   
   for (i=0; i<Osobniki[Rodzice[0]]->nGenow; i++)
   {
      Dzieci[0]->Genotyp[i] = a*Osobniki[Rodzice[0]]->Genotyp[i]+
                              (1-a)*Osobniki[Rodzice[1]]->Genotyp[i];
      Dzieci[1]->Genotyp[i] = a*Osobniki[Rodzice[1]]->Genotyp[i]+
                              (1-a)*Osobniki[Rodzice[0]]->Genotyp[i];
   }
   for (i=0; i<Osobniki[Rodzice[0]]->nPar; i++)
   {
      if (dwupunktowy(a))
      {
         Dzieci[0]->Parametry[i] = Osobniki[Rodzice[0]]->Parametry[i];
         Dzieci[1]->Parametry[i] = Osobniki[Rodzice[1]]->Parametry[i];
      }
      else
      {
         Dzieci[0]->Parametry[i] = Osobniki[Rodzice[1]]->Parametry[i];
         Dzieci[1]->Parametry[i] = Osobniki[Rodzice[0]]->Parametry[i];
      }
   }
   return 0;
}

/*----------------------------------------------------------------------------
Krzyzowanie usredniajace  --- wariant zmodyfikowany (w przestrzeni).
Uogolnione na przypadek samocyznnej adaptacji (musi byc jednakowa liczba
genow i parametrow).
----------------------------------------------------------------------------*/

char kUsrMod (const OSOBNIK *Osobniki, const unsigned *Rodzice,
            const unsigned nRodzicow, const unsigned nDzieci,
            const OSOBNIK *Dzieci)
{
   double ai;
   unsigned i;

   assert(nRodzicow==2);
   assert(nDzieci==2);

   for (i=0; i<Osobniki[Rodzice[0]]->nGenow; i++)
   {
      ai = jednostajny();
      Dzieci[0]->Genotyp[i] = ai*Osobniki[Rodzice[0]]->Genotyp[i]+
                              (1-ai)*Osobniki[Rodzice[1]]->Genotyp[i];
      Dzieci[1]->Genotyp[i] = ai*Osobniki[Rodzice[1]]->Genotyp[i]+
                              (1-ai)*Osobniki[Rodzice[0]]->Genotyp[i];
      if (Osobniki[Rodzice[0]]->nPar==Osobniki[Rodzice[0]]->nGenow)
         if (dwupunktowy(ai))
         {
            Dzieci[0]->Parametry[i] = Osobniki[Rodzice[0]]->Parametry[i];
            Dzieci[1]->Parametry[i] = Osobniki[Rodzice[1]]->Parametry[i];
         }
         else
         {
            Dzieci[0]->Parametry[i] = Osobniki[Rodzice[1]]->Parametry[i];
            Dzieci[1]->Parametry[i] = Osobniki[Rodzice[0]]->Parametry[i];
         }

   }
   return 0;
}

/***************************************************************************/
/*               WIELOOSOBNICZE KRYZOWANIE N->1                            */
/***************************************************************************/


/*----------------------------------------------------------------------------
Krzyzowanie rownomierne.
Uogolnione na przypadek samoczynnej adaptacji.
----------------------------------------------------------------------------*/

char kNRown (const OSOBNIK *Osobniki, const unsigned *Rodzice,
            const unsigned nRodzicow, const unsigned nDzieci,
            const OSOBNIK *Dzieci)
{
   unsigned *RozkladZamiany;
   unsigned i;

   assert(nRodzicow>=2);
   assert(nDzieci==1);

   RozkladZamiany=(unsigned*)calloc (nRodzicow, sizeof(unsigned));
   dyskNWym(RozkladZamiany, nRodzicow, nRodzicow);


   for (i=0; i<Osobniki[Rodzice[0]]->nGenow ; i++)
   {
      Dzieci[0]->Genotyp[i] = Osobniki[Rodzice[ RozkladZamiany[i] ]]->Genotyp[i];
      if (Osobniki[Rodzice[0]]->nPar==Osobniki[Rodzice[0]]->nGenow)
          Dzieci[0]->Parametry[i] = Osobniki[Rodzice[RozkladZamiany[i]]]->Parametry[i];
   }

   free (RozkladZamiany);
   return 0;
}

/*----------------------------------------------------------------------------
Kombinacja wypukla --- wariant standardowy.
Uogolnione na przypadk samoczynnej adaptacji - rownomierne tutaj.
----------------------------------------------------------------------------*/

char kNUsrStd (const OSOBNIK *Osobniki, const unsigned *Rodzice,
            const unsigned nRodzicow, const unsigned nDzieci,
            const OSOBNIK *Dzieci)
{
   double *TabWsp;
   unsigned i,j, a;

   assert(nRodzicow>=2);
   assert(nDzieci==1);

/* przygotowanie tablicy wspolczynnikow usredniania */
   TabWsp = (double*)calloc (nRodzicow, sizeof(double));
   normJednNWym (TabWsp, nRodzicow); 

   for (i=0; i<Osobniki[Rodzice[0]]->nGenow; i++)
   {
      Dzieci[0]->Genotyp[i]=0;
      for (j=0; j<nRodzicow; j++)
         Dzieci[0]->Genotyp[i] += TabWsp[j]*Osobniki[Rodzice[j]]->Genotyp[i];

   }
   for (i=0; i<Osobniki[Rodzice[0]]->nPar; i++)
   {
      a=ruletka (TabWsp, nRodzicow);
        Dzieci[0]->Parametry[i] = Osobniki[Rodzice[a]]->Parametry[i];
   }

   free (TabWsp);
   return 0;
}


/*----------------------------------------------------------------------------
Kombinacja wypukla --- wariant zmodyfikowany.
Uogolnione na przypadk samoczynnej adaptacji - rownomierne tutaj.
----------------------------------------------------------------------------*/

char kNUsrMod (const OSOBNIK *Osobniki, const unsigned *Rodzice,
            const unsigned nRodzicow, const unsigned nDzieci,
            const OSOBNIK *Dzieci)
{
   double *TabWsp;
   unsigned i, j, ai;


   assert(nRodzicow>=2);
   assert(nDzieci==1);

/* przygotowanie tablicy wspolczynnikow usredniania */
   TabWsp = (double*)calloc (nRodzicow, sizeof(double));

   for (i=0; i<Osobniki[Rodzice[0]]->nGenow ; i++)
   {
      normJednNWym (TabWsp, nRodzicow); 
      Dzieci[0]->Genotyp[i]=0;
      for (j=0; j<nRodzicow; j++)
         Dzieci[0]->Genotyp[i] += TabWsp[j]*Osobniki[Rodzice[j]]->Genotyp[i];

      if (Osobniki[Rodzice[0]]->nPar==Osobniki[Rodzice[0]]->nGenow)
      {
         ai=ruletka (TabWsp, nRodzicow);
           Dzieci[0]->Parametry[i] = Osobniki[Rodzice[ai]]->Parametry[i];
      }
   }

   free (TabWsp);
   return 0;
}


/***************************************************************************/
/*                           MUTACJE                                           */
/***************************************************************************/


/*----------------------------------------------------------------------------
Mutacja polegajaca na zamianie litery genotypu na wartosc losowa ze zbioru
liter alfabetu uzywanych do kodowania.
----------------------------------------------------------------------------*/

char mDysk (const OSOBNIK *Osobniki, const unsigned *Rodzice,
            const unsigned nRodzicow, const unsigned nDzieci,
            const OSOBNIK *Dzieci)
{
   unsigned i;

   assert(nRodzicow==1);
   assert(nDzieci==1);

   for (i=0; i<Osobniki[Rodzice[0]]->nGenow ; i++)
      if (dwupunktowy(Operatory->pMut))
         Dzieci[0]->Genotyp[i]=rownomierny (Zadanie->nLiter);
   return 0;
}


/*----------------------------------------------------------------------------
Mutacja z rozkladem prostokatnym - znudzilem sie
----------------------------------------------------------------------------*/

char mProst (const OSOBNIK *Osobniki, const unsigned *Rodzice,
            const unsigned nRodzicow, const unsigned nDzieci,
            const OSOBNIK *Dzieci)
{
   unsigned i;

   assert(nRodzicow==1);
   assert(nDzieci==1);

   for (i=0; i<Osobniki[Rodzice[0]]->nGenow; i++)
      if (dwupunktowy(Operatory->pMut))
         Dzieci[0]->Genotyp[i] = 
                        prostokatny(Zadanie->DolneX[i], Zadanie->GorneX[i]);
   return 0;
}

/*----------------------------------------------------------------------------
 Mutacja ze strategii ewolucyjnej, nieskorelowana, rozkladem normalnym.
----------------------------------------------------------------------------*/
char mNorm (const OSOBNIK *Osobniki, const unsigned *Rodzice,
            const unsigned nRodzicow, const unsigned nDzieci,
            const OSOBNIK *Dzieci)
{
   unsigned i;
   double N;

   assert(nRodzicow==1);
   assert(nDzieci==1);

   N=normstd();

   for (i=0; i<Osobniki[Rodzice[0]]->nGenow; i++)
   {
      if (Osobniki[Rodzice[0]]->nPar>0)
      {
         Dzieci[0]->Parametry[i] = Osobniki[Rodzice[0]]->Parametry[i]
		        *exp(Operatory->TAUP*N + Operatory->TAU*normstd() );
         if (Dzieci[0]->Parametry[i] < Operatory->MinSigma)
            Dzieci[0]->Parametry[i] = Operatory->MinSigma;
         Dzieci[0]->Genotyp[i] = Osobniki[Rodzice[0]]->Genotyp[i] +
                                 normstd()*Dzieci[0]->Parametry[i]; 
      }
      else
      {
         Dzieci[0]->Genotyp[i] = Osobniki[Rodzice[0]]->Genotyp[i] +
                                 normstd()*Operatory->MinSigma;
      }

   }
   return 0;
}

/*----------------------------------------------------------------------------
 Mutacja ze strategii ewolucyjnej, nieskorelowana, rozkladem Cauchy'ego
----------------------------------------------------------------------------*/

char mCauchy (const OSOBNIK *Osobniki, const unsigned *Rodzice,
            const unsigned nRodzicow, const unsigned nDzieci,
            const OSOBNIK *Dzieci)
{
   unsigned i;
   double N;

   assert(nRodzicow==1);
   assert(nDzieci==1);

   N=normstd();

   for (i=0; i<Osobniki[Rodzice[0]]->nGenow; i++)
   {
      if (Osobniki[Rodzice[0]]->nPar>0)
      {
         Dzieci[0]->Parametry[i] = Osobniki[Rodzice[0]]->Parametry[i]
		        *exp(Operatory->TAUP*N + Operatory->TAU*normstd() );
         if (Dzieci[0]->Parametry[i] < Operatory->MinSigma)
            Dzieci[0]->Parametry[i] = Operatory->MinSigma;
         Dzieci[0]->Genotyp[i] = Osobniki[Rodzice[0]]->Genotyp[i] +
                                 cauchy()*Dzieci[0]->Parametry[i]; 
      }
      else
      {
         Dzieci[0]->Genotyp[i] = Osobniki[Rodzice[0]]->Genotyp[i] +
                                 cauchy()*Operatory->MinSigma;
      }
   }
   return 0;
}



#define GEN_PAR 14
void okreslOperatory (FILE* plikKonf, FILE *plikKontr)
{
   char Wczytanych;
   char *Nazwy[GEN_PAR];
   CZYTFUN czytFun[GEN_PAR];
   void *Adresy[GEN_PAR];
   unsigned *Liczba[GEN_PAR];

   Operatory=(OPERATORY)malloc(sizeof(OPERATORYS));
   assert(Operatory!=NULL);

   Nazwy[0]="noperatorow"; czytFun[0]=czytUnsigned; Adresy[0]=&(Operatory->nOperatorowC); Liczba[0]=NULL;
   Nazwy[1]="npkrzyz"; czytFun[1]=czytUnsigned; Adresy[1]=&(Operatory->nPKrzyz); Liczba[1]=NULL;
   Nazwy[2]="tau"; czytFun[2]=czytDouble; Adresy[2]=&(Operatory->TAU); Liczba[2]=NULL;
   Nazwy[3]="taup"; czytFun[3]=czytDouble; Adresy[3]=&(Operatory->TAUP); Liczba[3]=NULL;
   Nazwy[4]="minsigma"; czytFun[4]=czytDouble; Adresy[4]=&(Operatory->MinSigma); Liczba[4]=NULL;
   Nazwy[5]="pmut"; czytFun[5]=czytDouble; Adresy[5]=&(Operatory->pMut); Liczba[5]=NULL;
   Nazwy[6]="pstwo"; czytFun[6]=czytNDouble; Adresy[6]=&(Operatory->PstwoC); Liczba[6]=&(Operatory->nOperatorowC);
   Nazwy[7]="nrodzicow"; czytFun[7]=czytNUnsigned; Adresy[7]=&(Operatory->nRodzicow); Liczba[7]=&(Operatory->nOperatorowC);
   Nazwy[8]="ndzieci"; czytFun[8]=czytNUnsigned; Adresy[8]=&(Operatory->nDzieci); Liczba[8]=&(Operatory->nOperatorowC);
   Nazwy[9]="toperatora"; czytFun[9]=czytNUnsigned; Adresy[9]=&(Operatory->tOperatoraC); Liczba[9]=&(Operatory->nOperatorowC);
   Nazwy[10]="pstwom"; czytFun[10]=czytNDouble; Adresy[10]=&(Operatory->PstwoM); Liczba[10]=&(Operatory->nOperatorowM);
   Nazwy[11]="toperatoram"; czytFun[11]=czytNUnsigned; Adresy[11]=&(Operatory->tOperatoraM); Liczba[11]=&(Operatory->nOperatorowM);
   Nazwy[12]="nakladanieop"; czytFun[12]=czytUnsigned; Adresy[12]=&(Operatory->NakladanieOp); Liczba[12]=NULL;
   Nazwy[13]="noperatorowm"; czytFun[13]=czytUnsigned; Adresy[13]=&(Operatory->nOperatorowM); Liczba[13]=NULL;

   Wczytanych = wczytajSymbole (plikKonf, plikKontr, Nazwy, czytFun, Adresy, Liczba, GEN_PAR);
/*   assert (Wczytanych==GEN_PAR);*/

}

