/*
+--------------------------------------+
|  (C) Jaroslaw Arabas, luty 1999      |
+--------------------------------------+
*/
#ifndef GENETYKA_H
#define GENETYKA_H

#include "osobnik.h"

/* Definicja operatora genetycznego. Wszystkie osobniki rodzicielskie znajduja
sie w tablicy Osobniki, tablica Rodzice okresla, ktore z nich zostana
zreprodukowane. Wynikiem jest tablica Dzieci. Parametr nDzieci okresla ich 
liczbe.
*/

char operatorG(unsigned Nr, const OSOBNIK *Osobniki, const unsigned *Rodzice,
                   const unsigned nRodzicow, const unsigned nDzieci,
                   const OSOBNIK *Dzieci);

/* Definicja struktury przechowujacej informacje o operatorach genetycznych.
Kazdy operator ma okreslona liczbe rodzicow i dzieci. Dodatkowo sa dane 
prawdopodobienstwa uzycia poszczegolnych operatorow, a takze wskazania do
funkcji realizujacych dzialanie operatorow.
*/

typedef struct{
   unsigned nOperatorowC;
   unsigned *tOperatoraC;
   double *PstwoC;
   unsigned *nRodzicow;
   unsigned *nDzieci;
   unsigned nOperatorowM;
   unsigned *tOperatoraM;
   double *PstwoM;
   unsigned nPKrzyz;
   double TAU;
   double TAUP;
   double MinSigma;
   double pMut;
   unsigned NakladanieOp;
} OPERATORYS;

typedef OPERATORYS* OPERATORY;

/* Fukcja konfiguruje -- tworzy informacje o operatorach i ustawia 
odpowiednie parametry */


void okreslOperatory (FILE*, FILE*);

extern OPERATORY Operatory;

/* Funkcja zwraca numer operatora z tablicy wszystkich dostepnych. Ktore
 * okresla, czy operatory krzyzowania (bazowe), czy tez operatory mutacyjne
 * beda brane pod uwage */
unsigned wyborOperatora (const OPERATORY Operatory, unsigned ktore); 

#endif
