/*
+--------------------------------------+
|  (C) Jaroslaw Arabas, listopad 1998  |
+--------------------------------------+
*/

/****************************************************************************

PLIK NAGLOWKOWY TYPOW I FUNKCJI ZWIAZANYCH Z ZADANIEM
Optymalizacja w R^n (rowniez wielokryterialna)

****************************************************************************/

#ifndef KONFIG_H
#define KONFIG_H

/* Zestawienie elementow uzytych do zdefiniowania poszczegolnych
   algorytmow */

typedef double TGEN;
//#include <values.h>
#include <float.h>
#define MAXDOUBLE DBL_MAX

#define ALG 0
#define PRZYKLAD 9
#define SMIERC -MAXDOUBLE


#if ALG==1
#define KODOWANIE   1
#define MUTACJA     3
#define KRZYZOWANIE 6
#define REPRODUKCJA 4
#define SUKCESJA    3
#define INICJACJA   1
#endif

#if ALG==2
#define KODOWANIE   2
#define MUTACJA     2
#define KRZYZOWANIE 4
#define REPRODUKCJA 2
#define SUKCESJA    1
#define INICJACJA   1
#endif

#if ALG==3
#define KODOWANIE   2
#define MUTACJA     2
#define KRZYZOWANIE 4
#define REPRODUKCJA 1
#define SUKCESJA    1
#define INICJACJA   1
#endif

#if ALG==4
#define KODOWANIE   1
#define MUTACJA     2 
/*3*/
#define KRZYZOWANIE 4
/*6*/
#define REPRODUKCJA 2
#define SUKCESJA    1
#define INICJACJA   1
#endif

#if ALG==5
#define KODOWANIE   3
#define MUTACJA     1
#define KRZYZOWANIE 3
#define REPRODUKCJA 1
#define SUKCESJA    1
#define INICJACJA   1
#endif

// Problem plecakowy - przyklad do rozdzialu "Algorytmy genetyczne"
#if PRZYKLAD==1
#define DL_ALFABETU 2
#define F_KARY 1
#define INICJACJA   2
#define KODOWANIE   3
#define KRZYZOWANIE 2
#define MINIMALIZACJA (char)-1
#define MUTACJA     1
#define OGRANICZ 1
#define REPRODUKCJA 1
#define SUKCESJA    1
#define TYP_FUNKCJI 2
#define TYP_ZADANIA 3
#define WAGA_OGR 1
#define ZATRZYMANIE 1
#define SZER_STOP 10
#define WYS_STOP 0
#endif

// Optymalizacja w R^n- przyklad do rozdzialu "Strategie ewolucyjne"
#if PRZYKLAD==2
#define INICJACJA   1
#define KODOWANIE   1
#define KRZYZOWANIE 6
#define MINIMALIZACJA (char)1
#define MUTACJA     3
#define OGRANICZ 0
#define REPRODUKCJA 1
#define SUKCESJA    2
#define TYP_FUNKCJI 1
#define TYP_ZADANIA 1
//#define MIN_SIGMA 0.1
#define ZATRZYMANIE 1
#define SZER_STOP 10
#define WYS_STOP 0.001
#endif

// Optymalizacja w R^n- przyklad do rozdzialu "Przeszukiwanie realizowane..."
#if PRZYKLAD==3
#define INICJACJA   1
#define KODOWANIE   1
#define KRZYZOWANIE 6
#define MINIMALIZACJA (char)1
#define MUTACJA     3
#define OGRANICZ 0
#define REPRODUKCJA 2
#define SUKCESJA    1
#define TYP_FUNKCJI 1
#define TYP_ZADANIA 1
#define ZATRZYMANIE 1
#define SZER_STOP 50
//#define MIN_SIGMA 0.1
#define WYS_STOP 0.001
#define MAX_GEN 100
#endif

// Problem plecakowy - ilustracja do podrozdziau o selekcji proporcjonalnej
#if PRZYKLAD==4
#define DL_ALFABETU 2
#define F_KARY 1
#define INICJACJA   2
#define KODOWANIE   3
#define KRZYZOWANIE 2
#define MINIMALIZACJA (char)-1
#define MUTACJA     1
#define OGRANICZ 1
#define REPRODUKCJA 1
#define SUKCESJA    1
#define TYP_FUNKCJI 2
#define TYP_ZADANIA 3
#define ZATRZYMANIE 1
#define SZER_STOP 100
//#define MIN_SIGMA 0.1
#define WAGA_OGR 1
#define WYS_STOP 0.0
#define MAX_GEN 100
#endif

// Problem plecakowy - ilustracja do podrozdziau o selekcji turniejowej
// Ten przyklad jest bardzo malo pouczajacy.
#if PRZYKLAD==5
#define DL_ALFABETU 2
#define F_KARY 1
#define INICJACJA   2
#define KODOWANIE   3
#define KRZYZOWANIE 2
#define MINIMALIZACJA (char)-1
#define MUTACJA     1
#define OGRANICZ 1
#define REPRODUKCJA 6
#define SUKCESJA    1
#define TYP_FUNKCJI 2
#define TYP_ZADANIA 3
#define ZATRZYMANIE 1
#define SZER_STOP 100
//#define MIN_SIGMA 0.1
#define WAGA_OGR 1
#define WYS_STOP 0.0
#define MAX_GEN 100
#endif

// Optymalizacja w R^n- ilustracja do 
// podrozdziau o selekcji turniejowej
// 
#if PRZYKLAD==6
#define INICJACJA   1
#define KODOWANIE   1
#define KRZYZOWANIE 6
#define MINIMALIZACJA (char)1
#define MUTACJA     3
#define OGRANICZ 0
#define REPRODUKCJA 6
#define SUKCESJA    1
#define TYP_FUNKCJI 1
#define TYP_ZADANIA 1
//#define MIN_SIGMA 0.1
#define ZATRZYMANIE 1
#define SZER_STOP 50
#define WYS_STOP 0.001
#endif


// Problem plecakowy - ilustracja do podrozdziau o selekcji rangowej
// 
#if PRZYKLAD==7
#define DL_ALFABETU 2
#define F_KARY 1
#define INICJACJA   2
#define KODOWANIE   3
#define KRZYZOWANIE 2
#define MINIMALIZACJA (char)-1
#define MUTACJA     1
#define OGRANICZ 1
#define REPRODUKCJA 3
#define SUKCESJA    1
#define TYP_FUNKCJI 2
#define TYP_ZADANIA 3
#define ZATRZYMANIE 1
#define SZER_STOP 100
#define MIN_SIGMA 0.1
#define WAGA_OGR 1
#define WYS_STOP 0.0
#define MAX_GEN 100
#endif

// Problem plecakowy - ilustracja do podrozdziau o selekcji 
// na etapie sukcesji - plus i przecinek
// 
#if PRZYKLAD==8
#define DL_ALFABETU 2
#define F_KARY 1
#define INICJACJA   2
#define KODOWANIE   3
#define KRZYZOWANIE 2
#define MINIMALIZACJA (char)-1
#define MUTACJA     1
#define OGRANICZ 1
#define REPRODUKCJA 4
#define SUKCESJA    2
#define TYP_FUNKCJI 2
#define TYP_ZADANIA 3
#define ZATRZYMANIE 1
#define SZER_STOP 100
#define MIN_SIGMA 0.1
#define WAGA_OGR 1
#define WYS_STOP 0.0
#define MAX_GEN 100
#endif

// Optymalizacja w R^n- przyklad do rozdzialu "Kryteria zatrzymania"
#if PRZYKLAD==9
#define INICJACJA   1
#define KODOWANIE   1
#define KRZYZOWANIE 6
#define MINIMALIZACJA (char)1
#define MUTACJA     3
#define OGRANICZ 0
#define REPRODUKCJA 2
#define SUKCESJA    1
#define TYP_FUNKCJI 1
#define TYP_ZADANIA 1
//#define MIN_SIGMA 0.001
#define ZATRZYMANIE 5
#define SZER_STOP 100
#define WYS_STOP 0.0001
#define MAX_GEN 100000
#define MIN_PRZYST -2.5
#endif


#endif

