/*
+--------------------------------------+
|  (C) Jaroslaw Arabas, luty 1999      |
+--------------------------------------+
*/

#ifndef LOSOWE_H
#define LOSOWE_H

#include <stdio.h>

/* Struktura przechowujaca informacje o tym, ktore generatory sa uzywane.
*/

typedef struct{
unsigned tJednostajny;
unsigned tNormalny;
unsigned tInicjacji;

unsigned InitZiarno;
} LOSOWES;

typedef LOSOWES* LOSOWE;

/* rozklad jednostajny - na przedziale [0..1], bazowy dla 
pozostalych rozkladow */

double jednostajny ();

/* 
Zmienna losowa o rozkladzie normalnym standaryzowanym
*/
double normstd();



/* inicjacja procedur pseudolosowych */

void initLosowe();

/*
Zmienna losowa o rozkladzie podanym jako argument, okreslona na zbiorze liczb
calkowitych nieujemnych [0..n-1]. 
*/

unsigned ruletka (double* rozklad, unsigned n);

/* 
Zmienna losowa o rozkladzie dyskretnym, rownomiernym na zbiorze liczb 
calkowitych nieujemnych z zakresu [0..n-1]
*/
unsigned rownomierny (unsigned n);

/* 
Zmienna losowa o rozkladzie normalnym, o podanej wartosci oczekiwanej i 
standardowym odchyleniu
*/
void normalny (double *X, const double *Mu, const double *Sigma, const unsigned n);

/* 
Zmienna losowa o rozkladzie projstokatnym, tj jednostajnym na zbiorze liczb 
rzeczywistych z zakresu [dolne .. gorne]
*/
double prostokatny (double dolne, double gorne);

/* Losowa permutacja zbioru n kolejnych liczb nieujemnych z zakresu [0..n-1]
W tablicy permutacja jest umieszczona wynikowa permutacja
*/

void permutacja (unsigned* permutacja, unsigned n);


/* 
Zmienna losowa o rozkladzie dwupunktowym, zwracajaca 
1 z pstwem jeden i 0 z pstwem 1-jeden
*/
char dwupunktowy (double jeden);

/*
Zmienna losowa o n-wymiarowym rozkladzie jednostajnym, kazdy z wymiarow 
ma zmiennosc od 0 do 1
*/
void jednNWym (double *wektor, unsigned n);

/*
Zmienna losowa o n-wymiarowym rozkladzie jednostajnym. 
Suma wartosci jest rowna 1.
*/
void normJednNWym (double *wektor, unsigned n);



/*
Zmienna losowa o n-wymiarowym rozkladzie jednostajnym, kazdy z wymiarow 
ma zmiennosc od 0 do n
*/
void dyskNWym (unsigned *wektor, unsigned n, unsigned k);

void kombinacja (unsigned* Wynik, unsigned n, unsigned k);

/* Rozklad Cauchy'ego standaryzowany */
double cauchy();

void okreslLosowe(FILE*,FILE*);

extern LOSOWE Losowe;

#endif


