/*
+--------------------------------------+
|  (C) Jaroslaw Arabas, listopad 1998  |
+--------------------------------------+
*/

#include <stdlib.h>
#include <stdio.h>
#include <assert.h>

#include "zadanie.h"
#include "osobnik.h"
#include "losowe.h"
#include "ogranicz.h"
#include "wewy.h"


OGRANICZENIA Ograniczenia;

double ogrBrak (OSOBNIK Osobnik);
double fKary (double Przekroczenie);
double ogrZKara (OSOBNIK Osobnik);
double ogrNaprawa (OSOBNIK Osobnik);

double fKLin (double Przekroczenie);


double fPrzystosowania (OSOBNIK Osobnik)
{
   switch (Ograniczenia->tOgraniczen)
   {
   case 1:  return ogrBrak(Osobnik);
   case 2:  return ogrZKara(Osobnik);
   case 3:  return ogrNaprawa(Osobnik);
   default: return -1;
   }
}

/* brak ograniczen - funkcja przystosowania tozsama z funkcja celu (z dokladoscia
do znaku */
double ogrBrak (OSOBNIK Osobnik)
{
   Osobnik->Przystosowanie=-Zadanie->Minimalizacja*(*(Zadanie->fcelu))(Osobnik->Genotyp, Osobnik->nGenow);
   return Osobnik->Przystosowanie;
}


/* Zewnetrzna funkcja kary - zalezna od wartosci przekroczen, nie odleglosci od
   obszaru dopuszczalnego*/

double fKary (double Przekroczenie)
{
   switch (Ograniczenia->tFKary)
   {
   case 1:  return fKLin (Przekroczenie);
   default: return 0;
   }
}

/* Liniowa funkcja */
double fKLin (double Przekroczenie)
{
   return Przekroczenie ;
}

double ogrZKara (OSOBNIK Osobnik)
{
   unsigned i;
   double Przekroczenie;
   Osobnik->Przystosowanie=-Zadanie->Minimalizacja*(*(Zadanie->fcelu))(Osobnik->Genotyp, Osobnik->nGenow);
   for (i=0; i<Zadanie->nNierown; i++)
   {
      Przekroczenie= (*(Zadanie->nierownosciowe[i]))(Osobnik->Genotyp, Osobnik->nGenow);
      if (Przekroczenie>0)
         Osobnik->Przystosowanie-=Ograniczenia->WagaOgr*fKary(Przekroczenie);
   }
/*   if (Osobnik->Przystosowanie<0)
      Osobnik->Przystosowanie=0;*/
   return Osobnik->Przystosowanie;
}


/* Funkcja naprawy sprowadzenie na ograniczenia kostkowe */
void naprawa (TGEN *x, unsigned n)
{
   unsigned i;

   for (i=0; i<n; i++)
	   if (x[i]<Zadanie->DolneX[i])
		   x[i]=Zadanie->DolneX[i];
	   else if (x[i]>Zadanie->GorneX[i])
		   x[i]=Zadanie->GorneX[i];
	   
}

double ogrNaprawa (OSOBNIK Osobnik)
{
   
   TGEN *Fenotyp;
   unsigned i;

   Fenotyp=(TGEN*)calloc(Osobnik->nGenow, sizeof (TGEN));
   for(i=0; i<Osobnik->nGenow; i++)
      Fenotyp[i]=Osobnik->Genotyp[i];

   naprawa(Fenotyp, Osobnik->nGenow);
   Osobnik->Przystosowanie=-Zadanie->Minimalizacja*(*(Zadanie->fcelu))(Fenotyp, Osobnik->nGenow);

   if (dwupunktowy(Ograniczenia->Lamarkizm))
   {
      free (Osobnik->Genotyp);
      Osobnik->Genotyp=Fenotyp;
   }
   else
      free (Fenotyp);
   return Osobnik->Przystosowanie;
}
#define OGR_PAR 4
void okreslOgraniczenia(FILE* plikKonf,FILE* plikKontr)
{
   char Wczytanych;
   char *Nazwy[OGR_PAR];
   CZYTFUN czytFun[OGR_PAR];
   void *Adresy[OGR_PAR];
   unsigned *Liczba[OGR_PAR];

   Ograniczenia = (OGRANICZENIA )malloc(sizeof(OGRANICZENIAS));
   assert(Ograniczenia!=NULL);

   Nazwy[0]="tograniczen"; czytFun[0]=czytUnsigned; Adresy[0]=&(Ograniczenia->tOgraniczen); Liczba[0]=NULL;
   Nazwy[1]="tfkary"; czytFun[1]=czytUnsigned; Adresy[1]=&(Ograniczenia->tFKary); Liczba[1]=NULL;
   Nazwy[2]="lamarkizm"; czytFun[2]=czytDouble; Adresy[2]=&(Ograniczenia->Lamarkizm); Liczba[2]=NULL;
   Nazwy[3]="wagaogr"; czytFun[3]=czytDouble; Adresy[3]=&(Ograniczenia->WagaOgr); Liczba[3]=NULL;

   Wczytanych = wczytajSymbole (plikKonf, plikKontr, Nazwy, czytFun, Adresy, Liczba, OGR_PAR);

/*   assert (Wczytanych==OGR_PAR);*/
}

