/*
+--------------------------------------+
|  (C) Jaroslaw Arabas, luty 1999      |
+--------------------------------------+
*/

#include <math.h>
#include <memory.h>
#include <stdlib.h>

#include "algorytm.h"
#include "losowe.h"
#include "osobnik.h"
#include "zadanie.h"


OSOBNIK osPrzesun(OSOBNIK *Osobnik)
{
   OSOBNIK Wynik = *Osobnik;

   *Osobnik = NULL;
   return Wynik;
}

OSOBNIK osKopiuj (OSOBNIK Osobnik)
{
   OSOBNIK Nowy = NULL;
   unsigned i;

   Nowy = osNowy();
   for(i=0; i<Osobnik->nGenow; i++)
      Nowy->Genotyp[i]=Osobnik->Genotyp[i];
   if (Osobnik->nPar >0)
      for(i=0; i<Osobnik->nPar; i++)
         Nowy->Parametry[i]=Osobnik->Parametry[i];
   Nowy->Przystosowanie=Osobnik->Przystosowanie;
   Osobnik->LKopii++;
   return Nowy;
}


void osUsun (OSOBNIK* Osobnik)
{
   free ((*Osobnik)->Genotyp);
   if ((*Osobnik)->nPar>0)
      free ((*Osobnik)->Parametry);
   free (*Osobnik);
   *Osobnik=NULL;

}

OSOBNIK osNowy ()
{
   OSOBNIK Nowy;
   unsigned i;

   Nowy = (OSOBNIK)malloc (sizeof(OSOBNIKS));
   Nowy->nGenow = Zadanie->nZmiennych;
   if (Algorytm->Samoadaptacja)
   {
      Nowy->nPar = Zadanie->nZmiennych;
      Nowy->Parametry = (double*)calloc (Nowy->nPar, sizeof(double));
      for (i=0; i<Nowy->nPar; i++)
	 Nowy->Parametry[i]=prostokatny(0,(Zadanie->GorneX[i]-Zadanie->DolneX[i])/(3*Zadanie->nZmiennych));
   }
   else
      Nowy->nPar = 0;
   Nowy->Genotyp = (TGEN*)calloc (Nowy->nGenow, sizeof(TGEN));
   Nowy->Wiek = 0;
   Nowy->LKopii=0;
   return Nowy;
}


char wKostkowych(OSOBNIK Osobnik)
{
   unsigned i;
   if (!Zadanie->saKostkowe)
      return 1;
   else
      for (i=0; i<Osobnik->nGenow; i++)
      {
         if (Osobnik->Genotyp[i] > Zadanie->GorneX[i])
            return 0;
         if (Osobnik->Genotyp[i] < Zadanie->DolneX[i])
            return 0;
      }
   return 1;

}

OSOBNIK osKopiuj2 (OSOBNIK Osobnik)
{
   OSOBNIK Wynik;
   Wynik=osKopiuj(Osobnik);
   Osobnik->LKopii--;
   return Wynik;
}
