/*
+--------------------------------------+
|  (C) Jaroslaw Arabas, listopad 1998  |
+--------------------------------------+
*/

#ifndef POP_H
#define POP_H

#include "monitor.h"
#include "osobnik.h"

/* Populacja jest reprezentowana jako wskaznik do struktury
*/
typedef struct 
{
   unsigned nOsobnik;
   OSOBNIK* Osobniki;
   MONPOP* Monitor;
} POPS;

typedef POPS* POP;

/* sortowanie populacji - wedlug kryterium optymalizacji */
void popSortuj (POP Populacja);

/* permutowanie populacji - ustawienie osobnikow w porzadku losowym */
void popPermutuj (POP Populacja);

/* ewaluacja populacji - obliczenie wartosci przystosowania dla wszystkich
   osobnikow populacji */
void popEwaluacja (POP Populacja);

/* inicjacja populacji - utworzenie i wypelnienie jej nowymi osobnikami */
void popInic(POP Populacja);

/* inicjacja populacji - utworzenie i wypelnienie jej nowymi osobnikami */
void popOsobniki(POP Populacja);

/* usuniecie osobnikow z populacji */
void popCzysc(POP Populacja);

POP popNowa(unsigned Licznosc);

void popUsun(POP Populacja);

void popMonitor(POP Populacja);

double popZroznicowanie(POP Pop);

void zadMonitor(unsigned t,POP Populacja);

#endif

