#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <assert.h>
#include "osobnik.h"
#include "pop.h"
#include "raporty.h"
#include "wewy.h"

RAPORTY Raporty;

char znakSpecjalny(char Nastepny)
{
   switch (Nastepny)
   {
      case 'n': return '\n';
      case '\\': return '\\';
      case 't': return '\t';
      default: return 0;
   }
}
void rapPop(POP Pop, char* ParZewn)
{
   unsigned i,j;
   char *Parametry;
   char Specjalny;

   if (ParZewn==NULL)
      Parametry=Raporty->RapPop;
   else
      Parametry=ParZewn;

   j=0;
   while (Parametry[j]!=0)
   {
      switch (Parametry[j])
      {
      case 'o':
      case 'O':
         for (i=0; i<Pop->nOsobnik; i++)
            rapOsobnik(Pop->Osobniki[i],Raporty->RapOs);
         break;
      case 'z':
      case 'Z':
         printf("%lf ", Pop->Monitor->Zroznicowanie);
         break;
      case 's':
      case 'S':
         rapOsobnik(Pop->Monitor->Sredni, Raporty->RapSredni);
         break;
      case 'x':
      case 'X':
         rapOsobnik(Pop->Osobniki[Pop->Monitor->Maksimum], Raporty->RapMax);
         break;
      case 'n':
      case 'N':
         rapOsobnik(Pop->Osobniki[Pop->Monitor->Minimum], Raporty->RapMin);
         break;
      case '~':
         printf(" ");
         break;
      case '\\':
         Specjalny=znakSpecjalny(Parametry[++j]);
         if (Specjalny!=0)
            printf("%c",Specjalny);
         break;
      default:
         printf("%c",Parametry[j]);
         break;
      }
      j++;
   }

   fflush(stdout);
}
//void rapOsobnik(OSOBNIK Osobnik, const char* Parametry);

void rapOsobnik(OSOBNIK Osobnik, char* ParZewn)
{
   unsigned i,j;
   char *Parametry;
   char Specjalny;

   if (ParZewn==NULL)
      Parametry="";
   else
      Parametry=ParZewn;

   j=0;
   while (Parametry[j]!=0)
   {
      switch (Parametry[j])
      {
      case 'x':
      case 'X':
         for (i=0; i<Osobnik->nGenow; i++)
	 {
            printf(Raporty->RapGen, Osobnik->Genotyp[i]);
	    printf(" ");
	  }
         break;
      case 'p':
      case 'P':
         for (i=0; i<Osobnik->nPar; i++)
            printf("%lf ", Osobnik->Parametry[i]);
         break;
      case 'w':
      case 'W':
         printf("%u ", Osobnik->Wiek);
         break;
      case 'k':
      case 'K':
         printf("%u ", Osobnik->LKopii);
         break;
      case 'f':
      case 'F':
         printf("%lf ", Osobnik->Przystosowanie);
         break;
      case '~':
         printf(" ");
         break;
      case '\\':
         Specjalny=znakSpecjalny(Parametry[++j]);
         if (Specjalny!=0)
            printf("%c",Specjalny);
         break;
      default:
         printf("%c",Parametry[j]);
         break;
      }
      j++;
   }

   fflush(stdout);
}

void rapZadanie(ZADANIE Zadanie, char* ParZewn)
{
   unsigned j;
   char *Parametry;
   char Specjalny;

   if (ParZewn==NULL)
      Parametry=Raporty->RapZad;
   else
      Parametry=ParZewn;

   j=0;
   while (Parametry[j]!=0)
   {
      switch (Parametry[j])
      {
      case 't':
      case 'T':
         printf("%u ",Zadanie->Monitor->Generacja);
         break;
      case 'r':
      case 'R':
         rapOsobnik(Zadanie->Monitor->Rozwiazanie, Raporty->RapRozw);
         break;
      case '~':
         printf(" ");
         break;
      case '\\':
         Specjalny=znakSpecjalny(Parametry[++j]);
         if (Specjalny!=0)
            printf("%c",Specjalny);
         break;
      default:
         printf("%c",Parametry[j]);
         break;
      }
      j++;
   }
   fflush(stdout);

}

#define RAP_PAR 8
void okreslRaporty(FILE* plikKonf,FILE* plikKontr)
{
   char Wczytanych;
   char *Nazwy[RAP_PAR];
   CZYTFUN czytFun[RAP_PAR];
   void *Adresy[RAP_PAR];
   unsigned *Liczba[RAP_PAR];

   Raporty=(RAPORTY)malloc(sizeof(RAPORTYS));
   assert(Raporty!=NULL);

   Nazwy[0]="rapgen"; czytFun[0]=czytLancuch; Adresy[0]=&(Raporty->RapGen); Liczba[0]=NULL;
   Nazwy[1]="rappop"; czytFun[1]=czytLancuch; Adresy[1]=&(Raporty->RapPop); Liczba[1]=NULL;
   Nazwy[2]="rapos"; czytFun[2]=czytLancuch; Adresy[2]=&(Raporty->RapOs); Liczba[2]=NULL;
   Nazwy[3]="rapsredni"; czytFun[3]=czytLancuch; Adresy[3]=&(Raporty->RapSredni); Liczba[3]=NULL;
   Nazwy[4]="rapmin"; czytFun[4]=czytLancuch; Adresy[4]=&(Raporty->RapMin); Liczba[4]=NULL;
   Nazwy[5]="rapmax"; czytFun[5]=czytLancuch; Adresy[5]=&(Raporty->RapMax); Liczba[5]=NULL;
   Nazwy[6]="rapzad"; czytFun[6]=czytLancuch; Adresy[6]=&(Raporty->RapZad); Liczba[6]=NULL;
   Nazwy[7]="raprozw"; czytFun[7]=czytLancuch; Adresy[7]=&(Raporty->RapRozw); Liczba[7]=NULL;

   Wczytanych = wczytajSymbole (plikKonf, plikKontr, Nazwy, czytFun, Adresy, Liczba, RAP_PAR);

/*   assert (Wczytanych==RAP_PAR);*/
}

