#include "wewy.h"
#include "genetyka.h"
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <assert.h>

char czytNUnsigned(FILE* Zrodlo, FILE* Kontrola, void* miejsce, unsigned Liczba)
{
   unsigned *Dokad;
   unsigned i;
   unsigned nWczytanych=0;

   Dokad = (unsigned*)calloc(Liczba, sizeof(unsigned));
   assert (Dokad!=NULL);
   for (i=0; i<Liczba ; i++)
   {
      if ( fscanf(Zrodlo, "%u", Dokad+i) == EOF )
         return nWczytanych;
      nWczytanych++;
      fprintf(Kontrola, "%u ", Dokad[i]);
   }
   *((unsigned**)miejsce)=Dokad;
   return nWczytanych;
}

char czytNDouble(FILE* Zrodlo, FILE* Kontrola, void* miejsce, unsigned Liczba)
{
   double *Dokad;
   unsigned i;
   unsigned nWczytanych=0;

   Dokad = (double*)calloc(Liczba , sizeof(double));
   assert (Dokad!=NULL);
   for (i=0; i<Liczba ; i++)
   {
      if ( fscanf(Zrodlo, "%lf", Dokad+i) == EOF )
         return nWczytanych;
      fprintf(Kontrola, "%lf ", Dokad[i]);
   }
   *((double**)miejsce)=Dokad;
   return nWczytanych;
}

char czytDouble(FILE* Zrodlo, FILE* Kontrola, void* miejsce, unsigned Liczba)
{
   double Dokad;
   assert (Liczba==1);
   if ( fscanf(Zrodlo, "%lf", &Dokad) == EOF )
      return EOF;
   fprintf(Kontrola, "%lf ", Dokad);
   *((double*)miejsce)=Dokad;
   return 1;
}

char czytUnsigned(FILE* Zrodlo, FILE* Kontrola, void* miejsce, unsigned Liczba)
{
   unsigned Dokad;
   assert (Liczba==1);
   if ( fscanf(Zrodlo, "%u", &Dokad) == EOF )
      return EOF;
   fprintf(Kontrola, "%u ", Dokad);
   *((unsigned*)miejsce)=Dokad;
   return 1;
}

#define MAX_ZNAK 100
/*char czytLancuch(FILE* Zrodlo, FILE* Kontrola, void* miejsce, unsigned Liczba)
{
   char Bufor[MAX_ZNAK+1];
   char* Buf2;
   assert (Liczba==1);
   fgets(Bufor, MAX_ZNAK, Zrodlo);
   Buf2 = strdup(Bufor);
   *(char**)miejsce = Buf2;
   fprintf(Kontrola, "%s ", Bufor);
   return 1;
}
*/
char czytLancuch(FILE* Zrodlo, FILE* Kontrola, void* miejsce, unsigned Liczba)
{
   char Bufor[MAX_ZNAK+1];
   char* Buf2;
   assert (Liczba==1);
   if ( fscanf(Zrodlo, "%s", Bufor) == EOF )
      return EOF;
   Buf2 = strdup(Bufor);
   *(char**)miejsce = Buf2;
   fprintf(Kontrola, "%s ", Bufor);
   return 1;
}

/*void czytOperator(char* Zrodlo, FILE* Kontrola, void* miejsce)
{
   OPERATOR Operator;
   static unsigned liczba=0;

   Operator = (OPERATOR*) miejsce;
   fprintf(Kontrola, "operator nr %u: ", liczba+1);
   sscanf(Zrodlo, "%u", &(Operator->tOperatora));
   fprintf(Kontrola, "%u ", (Operator->tOperatora));
   sscanf(Zrodlo, "%lf", &(Operator->Pstwo));
   fprintf(Kontrola, "%lf ", (Operator->Pstwo));
   sscanf(Zrodlo, "%u", &(Operator->nRodzicow));
   fprintf(Kontrola, "%u ", (Operator->nRodzicow));
   sscanf(Zrodlo, "%u", &(Operator->nDzieci));
   fprintf(Kontrola, "%u ", (Operator->nDzieci));
}
*/
char wyborZListy (char *Nazwy[], char *Bufor, unsigned Liczba)
{
   unsigned i;

  // strtol(Bufor);
   for (i=0; i<Liczba; i++)
      if (!strcmp(Bufor, Nazwy[i]))
         return i;
   return -1;
}

char wczytajSymbole (FILE* Plik, FILE *Kontrola, char *Nazwy[], 
                     const CZYTFUN *czytFun, 
                     void** Adresy, unsigned *Liczba[], const unsigned IleMozliwosci)
{
   char Nazwa[101];
   char Wczytany, nWczytanych;
   char Symbol;


   nWczytanych=0;
   Wczytany = fscanf(Plik, "%s", Nazwa);

   while(Wczytany!=EOF)
   {
      Symbol=wyborZListy(Nazwy, Nazwa, IleMozliwosci);
      if (Symbol>=0 && Symbol <IleMozliwosci)
      {
         fprintf (Kontrola, "%s = ", Nazwa);
         if (Liczba[Symbol]!=NULL)
            Wczytany = (czytFun[Symbol])(Plik, Kontrola, Adresy[Symbol], *(Liczba[Symbol]));
         else
            Wczytany = (czytFun[Symbol])(Plik, Kontrola, Adresy[Symbol], 1);
          if (Wczytany == EOF)
             return nWczytanych;
        nWczytanych++;
        fprintf (Kontrola, "\n");
        fflush (Kontrola);
      }
      Wczytany = fscanf(Plik, "%s", Nazwa);
   }
   return nWczytanych;
}
