/*
+--------------------------------------+
|  (C) Jaroslaw Arabas, listopad 1998  |
+--------------------------------------+
*/

#include <assert.h>
#include <math.h>
#include <stdio.h>
#include <stdlib.h>

#include "defs.h"
#include "losowe.h"
#include "osobnik.h"
#include "wewy.h"
#include "zadanie.h"

#define ACKLEY

ZADANIE Zadanie;

double sqr(double x)
{ return (x*x);}

#define SH_N 5
double Shubert(const double *x, unsigned n)
{
   double s,w;
   unsigned i,j;
   
   //assert(n==2);
   w=1;
   for(j=0;j<n;j++)
   {
      s=0;
      for(i=1; i<=SH_N; i++)
         s+=i*cos((i+1)*x[j]+i);
      w*=s;
   }
   return w;
   


}

void inicjujCiagle()
{
   FILE *PlikKonf;
   int wynik;
   unsigned i;

   PlikKonf = fopen(Zadanie->plikDanych,"r");
   assert(PlikKonf!=NULL);
   wynik=fscanf(PlikKonf,"%d", &Zadanie->nZmiennych);
   assert(wynik==1);
   Zadanie->DolneX=(double*)calloc(Zadanie->nZmiennych, sizeof(double));
   Zadanie->GorneX=(double*)calloc(Zadanie->nZmiennych, sizeof(double));
   assert(Zadanie->DolneX!=NULL);
   assert(Zadanie->GorneX!=NULL);
   for(i=0; i<Zadanie->nZmiennych; i++)
   {
      wynik=fscanf(PlikKonf, "%lf%lf", &(Zadanie->DolneX[i]), &(Zadanie->GorneX[i]));
      assert(wynik==2);
   }
   fclose(PlikKonf);
}

#define ZAD_PAR 4
void okreslZadanie(FILE* plikKonf)
{
   char Wczytanych;
   char *Nazwy[ZAD_PAR];
   CZYTFUN czytFun[ZAD_PAR];
   void *Adresy[ZAD_PAR];
   unsigned *Liczba[ZAD_PAR];
   FILE* plikKontr;

   plikKontr=fopen("zadanie.log", "wt");
   assert(plikKontr!=NULL);

   Zadanie = (ZADANIE)malloc (sizeof(ZADANIES));
   assert(Zadanie!=NULL);


   Nazwy[0]="plikdanych"; czytFun[0]=czytLancuch ;Adresy[0]=&(Zadanie->plikDanych); Liczba[0]=NULL;
   Nazwy[1]="rozklad"; czytFun[1]=czytNDouble ;Adresy[1]=&(Zadanie->Rozklad); Liczba[1]=&(Zadanie->nLiter);
   Nazwy[2]="tinic"; czytFun[2]=czytUnsigned ;Adresy[2]=&(Zadanie->tInic); Liczba[2]=NULL;
   Nazwy[3]="nliter"; czytFun[3]=czytUnsigned ;Adresy[3]=&(Zadanie->nLiter); Liczba[3]=NULL;

   Wczytanych = wczytajSymbole (plikKonf, plikKontr, Nazwy, czytFun, Adresy, Liczba, ZAD_PAR);



   Zadanie->Monitor=inicjujMonZad();

   Zadanie->Minimalizacja=1;
   Zadanie->nRown=0;
   Zadanie->nNierown=0;
   inicjujCiagle();
   Zadanie->fcelu =Shubert;

   fclose(plikKontr);
}

void zadInicjuj(TGEN** Punkty, unsigned Liczba)
{
   unsigned i,j;

   for(i=0; i<Liczba; i++)
      for (j=0; j<Zadanie->nZmiennych; j++)
         (Punkty[i])[j]=prostokatny(Zadanie->DolneX[j], Zadanie->GorneX[j]);
}
