/*
+--------------------------------------+
|  (C) Jaroslaw Arabas, luty 1999      |
+--------------------------------------+
*/

#ifndef ZADANIE_H
#define ZADANIE_H

#include <stdio.h>
#include "osobnik.h"
#include "monitor.h"

/* Funkcja - typ uzywany w zadaniach optymalizacji jednokryterialnej*/
typedef double (*FUNKCJA)(const TGEN*, unsigned);

/* funkcje --- celu (rowniez wielokryterialnie), 
               ograniczen nierownosciowych, 
               ograniczen rownosciowych
            obszaru zainteresowania - ograniczen kostkowych
*/

typedef struct{
         unsigned nLiter; /* uzywane jedynie do przypadkow dysk. */
         unsigned nZmiennych;
#ifdef WIELOKRYT
         unsigned nCelow;
         FUNKCJA* fcelu;
         char *Minimalizacja;
#else
         FUNKCJA fcelu;
         char Minimalizacja;
#endif
         unsigned nNierown;
         FUNKCJA *nierownosciowe;
         unsigned nRown;
         FUNKCJA *rownosciowe;
         MONZAD *Monitor;
         unsigned saKostkowe;
         TGEN *GorneX;
         TGEN *DolneX;

         char* plikDanych;
         unsigned tInic;
         double* Rozklad;
      } ZADANIES;

typedef ZADANIES* ZADANIE;



/* funkcja przystosowania oblicza przystosowanie osobnika na podstawie jego 
   funkcji celu i ograniczen, zapisuje wyliczona wartosc wartosc oraz zwraca 
   ja jako wynik */
double fPrzystosowania (OSOBNIK Osobnik);

/* krytStopu okresla czy zostal spelniony warunek zatrzymania */
char krytStopu (ZADANIE Zadanie);

/*sluzy do definicji zadania optymalizacji - wymiarowosci, funkcji celu i
ograniczen */

void okreslZadanie(FILE*);

void zadInicjuj(TGEN**, unsigned);

extern ZADANIE Zadanie;

#endif


